     % Fast Sine Transform on input matrix V      % of dimension n-by-m
     function Y=fast_sine_transform(V)
     [n,m]=size(V); 
     V1=[zeros(1,m);V;zeros(n+1,m)]; 
     V2=imag(fft(V1)); 
     % In Matlab vectors and matrices are indexed 
     % starting at 1, not 0
     Y=V2(2:n+1,:);    

